#!/bin/sh

noparm=

while test $# -gt 0; do
	case "$1" in
		-p)	noparm=-p;;
		--)	shift; break;;
		*)	break;;
	esac
	shift
done

if test $# -ne 1; then
	echo "usage: mprnm [-p] a.out" >&2
	exit 1
fi

# handle labels showing up as functions, but only if coff and sco5

coff=
if file $1 | egrep -v ELF >/dev/null 2>&1; then
	if uname -X | grep "Release.*v5" >/dev/null 2>&1; then
		coff="-b coff"
	fi
fi

nm $coff -h -p $1 |

awk '
	NF==3 && $2 ~ /T|t|N|n/ && $3 !~ /^\.|(\.o$)|(g(nu|cc).*compiled)/ {
		printf "%s\t%s\n", $1, $3
	}' |

mprdem $noparm |

sed -e 's/global destructors keyed to /_GLOBAL_$D$/' \
    -e 's/global constructors keyed to /_GLOBAL_$C$/' \
    -e 's/::/<>/g' |

sort -n

exit 0
